
import UIKit
import CoreData

class EditBookViewController: UIViewController {
   @IBOutlet weak var bookTitle: UITextField!
   @IBOutlet weak var bookYear: UITextField!
   var context: NSManagedObjectContext!

   override func viewDidLoad() {
      super.viewDidLoad()
      let app = UIApplication.shared
      let appDelegate = app.delegate as! AppDelegate
      context = appDelegate.persistentContainer.viewContext

      bookTitle.becomeFirstResponder()
   }
   @IBAction func saveBook(_ sender: UIBarButtonItem) {
      let title = bookTitle.text!.trimmingCharacters(in: .whitespaces)
      let year = Int16(bookYear.text!)
      if title != "" && year != nil {
         Task(priority: .high) {
            await storeBook(title: title, year: year!)
         }
      }
   }
   func storeBook(title: String, year: Int16) async {
      await context.perform {
         let newBook = Books(context: self.context)
         newBook.title = title
         newBook.year = year
         newBook.thumbnail = UIImage(named: "nothumbnail")?.pngData()

         do {
            try self.context.save()
            self.closeScene()
         } catch {
            print("Error: \(error)")
         }
      }
   }
   func closeScene() {
      Task(priority: .high) {
         await MainActor.run {
            navigationController?.popViewController(animated: true)
         }
      }
   }
}

