
import UIKit
import CoreData

enum Sections {
   case main
}
class ApplicationData {
   var dataSourceBooks: MyDataSource!
   var dataSourceAuthors: UITableViewDiffableDataSource<Sections, NSManagedObjectID>!

   var listOfBooks: [Books] = []
   var listOfAuthors: [Authors] = []

   func loadRequestBooks(context: NSManagedObjectContext) async {
      await context.perform {
         let request: NSFetchRequest<Books> = Books.fetchRequest()
         let sort = NSSortDescriptor(key: "title", ascending: true, selector: #selector(NSString.caseInsensitiveCompare(_:)))
         request.sortDescriptors = [sort]
         do {
            self.listOfBooks = try context.fetch(request)
         } catch {
            print("Error")
         }
      }
   }
   func prepareSnapshotBooks() {
      var snapshot = NSDiffableDataSourceSnapshot<Sections, NSManagedObjectID>()
      snapshot.appendSections([.main])
      snapshot.appendItems(self.listOfBooks.map({ $0.objectID }))
      dataSourceBooks.apply(snapshot)
   }
}
var AppData = ApplicationData()

