
import UIKit
import CoreData

class MyDataSource: UITableViewDiffableDataSource<Sections, NSManagedObjectID> {
   override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
      return true
   }
   override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCell.EditingStyle, forRowAt indexPath: IndexPath) {
      if editingStyle == .delete {
         if let itemID = AppData.dataSourceBooks.itemIdentifier(for: indexPath) {
            let app = UIApplication.shared
            let appDelegate = app.delegate as! AppDelegate
            let context = appDelegate.persistentContainer.viewContext

            if let item = AppData.listOfBooks.first(where: { $0.objectID == itemID }) {
               Task(priority: .high) {
                  await deleteBook(context: context, item: item)
               }
            }
         }
      }
   }
   func deleteBook(context: NSManagedObjectContext, item: Books) async {
      await context.perform {
         context.delete(item)
         do {
            try context.save()
         } catch {
            print("Error: \(error)")
         }
      }
      await AppData.loadRequestBooks(context: context)

      await MainActor.run {
         AppData.prepareSnapshotBooks()
      }
   }
}

