
import UIKit
import CoreData

class EditAuthorViewController: UIViewController {
   @IBOutlet weak var authorName: UITextField!
   var context: NSManagedObjectContext!
   var selectedAuthor: Authors!

   override func viewDidLoad() {
      super.viewDidLoad()
      let app = UIApplication.shared
      let appDelegate = app.delegate as! AppDelegate
      context = appDelegate.persistentContainer.viewContext

      authorName.becomeFirstResponder()
   }
   @IBAction func saveAuthor(_ sender: UIBarButtonItem) {
      let name = authorName.text!.trimmingCharacters(in: .whitespaces)
      if name != "" {
         Task(priority: .high) {
            await storeAuthor(name: name)
         }
      }
   }
   func storeAuthor(name: String) async {
      await context.perform {
         let request: NSFetchRequest<Authors> = Authors.fetchRequest()
         request.predicate = NSPredicate(format: "name = %@", name)

         if let total = try? self.context.count(for: request), total <= 0 {
            self.selectedAuthor = Authors(context: self.context)
            self.selectedAuthor.name = name

            do {
               try self.context.save()
               self.closeScene()
            } catch {
               print("Error: \(error)")
            }
         }
      }
   }
   func closeScene() {
      Task(priority: .high) {
         await MainActor.run {
            performSegue(withIdentifier: "backFromNew", sender: self)
         }
      }
   }
}

