
import UIKit
import CoreData

class EditBookViewController: UIViewController {
   @IBOutlet weak var bookTitle: UITextField!
   @IBOutlet weak var bookYear: UITextField!
   @IBOutlet weak var authorName: UILabel!
   var context: NSManagedObjectContext!
   var selectedAuthor: Authors!

   override func viewDidLoad() {
      super.viewDidLoad()
      let app = UIApplication.shared
      let appDelegate = app.delegate as! AppDelegate
      context = appDelegate.persistentContainer.viewContext

      bookTitle.becomeFirstResponder()
   }
   @IBAction func saveBook(_ sender: UIBarButtonItem) {
      let title = bookTitle.text!.trimmingCharacters(in: .whitespaces)
      let year = Int16(bookYear.text!)
      if title != "" && year != nil {
         Task(priority: .high) {
            await storeBook(title: title, year: year!)
         }
      }
   }
   func storeBook(title: String, year: Int16) async {
      await context.perform {
         let newBook = Books(context: self.context)
         newBook.title = title
         newBook.year = year
         newBook.author = self.selectedAuthor

         do {
            try self.context.save()
            self.closeScene()
         } catch {
            print("Error: \(error)")
         }
      }
   }
   func closeScene() {
      Task(priority: .high) {
         await MainActor.run {
            navigationController?.popViewController(animated: true)
         }
      }
   }
   @IBAction func backAuthor(_ segue: UIStoryboardSegue) {
      if segue.identifier == "backFromList" {
         let controller = segue.source as! AuthorsViewController
         selectedAuthor = controller.selectedAuthor
         authorName.text = selectedAuthor.name
      } else if segue.identifier == "backFromNew" {
         let controller = segue.source as! EditAuthorViewController
         selectedAuthor = controller.selectedAuthor
         authorName.text = selectedAuthor.name
      }
   }
}

